#include <sourcemod>
#include <vip_core>
#pragma semicolon 1
#pragma newdecls required

#define DEFAULT_DUCK_SPEED 6.023437

int				m_flDuckSpeed,
				g_bDuckSpeedState[MAXPLAYERS+1];
float			g_flPlayerDuckSpeed[MAXPLAYERS + 1];
GlobalForward	g_hForwardPlayerDuck,
				g_hForwardPlayerDuckPost;

static const char g_sFeature[] = "DuckSpeed";

public Plugin myinfo = 
{
	name = "[VIP] Duck Speed",
	author = "Wend4r",
	version = "1.0.0",
	url = "Discord: Wend4r#0001 | VK: vk.com/wend4r"
}

public APLRes AskPluginLoad2(Handle hMySelf, bool bLate, char[] sError, int iErrorSize)
{
	if(GetEngineVersion() != Engine_CSGO)
	{
		strcopy(sError, iErrorSize, "This plugin works only on CS:GO");

		return APLRes_SilentFailure;
	}

	CreateNative("GetDuckSpeed", Native_GetDuckSpeed);
	CreateNative("SetDuckSpeed", Native_SetDuckSpeed);

	g_hForwardPlayerDuck = new GlobalForward("OnPlayerDuck", ET_Event, Param_Cell, Param_CellByRef);
	g_hForwardPlayerDuckPost = new GlobalForward("OnPlayerDuckPost", ET_Ignore, Param_Cell, Param_Cell);

	RegPluginLibrary("VIP_Duck_Speed");

	return APLRes_Success;
}

int Native_GetDuckSpeed(Handle hPlugin, int iArgs)
{
	return view_as<int>(g_flPlayerDuckSpeed[GetNativeCell(1)]);
}

int Native_SetDuckSpeed(Handle hPlugin, int iArgs)
{
	int   iClient = GetNativeCell(1);
	float flDuckSpeed = GetNativeCell(2);

	if(iClient == -1)
	{
		for(iClient = MaxClients + 1; --iClient;)
		{
			g_flPlayerDuckSpeed[iClient] = flDuckSpeed;
		}
	}
	else
	{
		g_flPlayerDuckSpeed[iClient] = flDuckSpeed;
	}
}

public void OnPluginStart()
{
	ConVar hCvar = CreateConVar("sm_duck_speed_enable", "1", "Is this plugin actions enabled", _, true, 0.0, true, 1.0);

	hCvar.AddChangeHook(OnEnableConVarChanged);
	OnEnableConVarChanged(hCvar, NULL_STRING, NULL_STRING);

	m_flDuckSpeed = FindSendPropInfo("CBasePlayer", "m_flDuckSpeed");

	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
}

void OnEnableConVarChanged(ConVar hCvar, const char[] sOldValue, const char[] sNewValue)
{
	if(hCvar.BoolValue)
	{
		for(int i = MaxClients + 1; --i;)
		{
			g_flPlayerDuckSpeed[i] = DEFAULT_DUCK_SPEED;
		}
	}
	else
	{
		for(int i = MaxClients + 1; --i;)
		{
			g_flPlayerDuckSpeed[i] = -1.0;
		}
	}
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, BOOL);
}

public void OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public void OnClientDisconnect(int iClient)
{
	g_bDuckSpeedState[iClient] = 0;
}

public void VIP_OnVIPClientLoaded(int iClient)
{
	g_bDuckSpeedState[iClient] = view_as<int>(VIP_GetClientFeatureStatus(iClient, g_sFeature));
}

public Action VIP_OnFeatureToggle(int iClient, const char[] szFeature, VIP_ToggleState eOldStatus, VIP_ToggleState &eNewStatus)
{
	if(StrContains(szFeature, g_sFeature) != -1)
	{
		g_bDuckSpeedState[iClient] = view_as<int>(eNewStatus);
	}
	return Plugin_Continue;
}

public void OnPlayerRunCmdPost(int iClient, int iButtons)
{
	static int iOldButtons[MAXPLAYERS + 1];

	if(g_bDuckSpeedState[iClient] == 1 && iButtons & IN_DUCK && !(iOldButtons[iClient] & IN_DUCK))
	{
		// PrintToChat(iClient, "%f", GetEntDataFloat(iClient, m_flDuckSpeed));

		float flDuckSpeed = g_flPlayerDuckSpeed[iClient];

		if(g_hForwardPlayerDuck.FunctionCount)
		{
			Action iReturn;

			Call_StartForward(g_hForwardPlayerDuck);
			Call_PushCell(iClient);
			Call_PushCellRef(flDuckSpeed);
			Call_Finish(iReturn);

			if(iReturn == Plugin_Handled)
			{
				return;
			}
		}

		if(g_flPlayerDuckSpeed[iClient] != -1.0)
		{
			SetEntDataFloat(iClient, m_flDuckSpeed, flDuckSpeed);
		}

		if(g_hForwardPlayerDuckPost.FunctionCount)
		{
			Call_StartForward(g_hForwardPlayerDuck);
			Call_PushCell(iClient);
			Call_PushCell(flDuckSpeed);
			Call_Finish();
		}
	}

	iOldButtons[iClient] = iButtons;
}
